# TODO
# - build it from sources
#   https://hudson.dev.java.net/files/documents/2402/125619/hudson-1.280-src.zip
# - use system jars
# - subpackages (see ubuntu packages for splitting contents)
%include	/usr/lib/rpm/macros.java
Summary:	Jenkins Continuous Build Server
Name:		jenkins
Version:	1.625.2
Release:	1
License:	MIT License
Group:		Networking/Daemons/Java/Servlets
# Check for new releases and URLs here:
# Source0Download: http://mirrors.jenkins-ci.org/war-stable/?C=N;O=D
Source0:	http://mirrors.jenkins-ci.org/war-stable/%{version}/%{name}.war?/%{name}-%{version}.war
# Source0-md5:	3b99b4991e0186102c67ac9166cda056
Source1:	context.xml
Patch0:		webxml.patch
URL:		http://www.jenkins-ci.org/
BuildRequires:	jpackage-utils
BuildRequires:	rpm-javaprov
BuildRequires:	rpmbuild(macros) >= 1.546
Requires:	jpackage-utils
Requires:	jre-X11 >= 1.7
Requires:	tomcat
Suggests:	%{name}-plugin-maven
Obsoletes:	hudson < 1.396
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Jenkins monitors executions of repeated jobs, such as building a
software project or jobs run by cron.

Among those things, current Jenkins focuses on the following two jobs:
- Building/testing software projects continuously, just like
  CruiseControl or DamageControl. In a nutshell, Jenkins provides an
  easy-to-use so-called continuous integration system, making it easier
  for developers to integrate changes to the project, and making it
  easier for users to obtain a fresh build. The automated, continoues
  build increases the productivity.
- Monitoring executions of externally-run jobs, such as cron jobs and
  procmail jobs, even those that are run on a remote machine. For
  example, with cron, all you receive is regular e-mails that capture
  the output, and it is up to you to look at them diligently and notice
  when it broke. Jenkins keeps those outputs and makes it easy for you
  to notice when something is wrong.

%package plugin-maven
Summary:	Jenkins Maven 2 Project Plugin
Group:		Networking/Daemons/Java/Servlets
URL:		https://wiki.jenkins-ci.org/display/JENKINS/Maven+2+Project+Plugin
Requires:	%{name} = %{version}-%{release}
Conflicts:	%{name} < %{version}-%{release}

%description plugin-maven
Maven Integration plugin.

%prep
%setup -qc
%{__rm} *.class
%{__rm} winstone.jar
%patch0 -p1

find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/%{name},%{_datadir}/%{name},%{_sharedstatedir}/%{name},%{_tomcatconfdir}}
mv WEB-INF/web.xml $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/web.xml
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/tomcat-context.xml
ln -sf %{_sysconfdir}/%{name}/tomcat-context.xml $RPM_BUILD_ROOT%{_tomcatconfdir}/%{name}.xml
cp -a . $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -sf %{_sysconfdir}/%{name}/web.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/WEB-INF/web.xml

%post
# If we have an old hudson install, rename it to jenkins
if test -d /var/lib/hudson; then
	echo >&2 "Moving /var/lib/hudson -> /var/lib/jenkins"
	# leave a marker to indicate this came from Hudson.
	# could be useful down the road
	# This also ensures that the .??* wildcard matches something
	touch /var/lib/hudson/.moving-hudson
	mv -f /var/lib/hudson/* /var/lib/hudson/.??* /var/lib/jenkins
	rmdir /var/lib/hudson
fi
if test -d /var/run/hudson; then
	mv -f /var/run/hudson/* /var/run/jenkins
	rmdir /var/run/hudson
fi

%postun
%tomcat_clear_cache %{name}

%triggerpostun -- %{name} < 1.509.1
test -f /var/lib/jenkins/hudson.model.UpdateCenter.xml || return
echo "Changing update center URL to LTS in /var/lib/jenkins/hudson.model.UpdateCenter.xml"
echo "See https://wiki.jenkins-ci.org/display/JENKINS/LTS+Release+Line"
sed -i.rpmorig -e 's,http://updates.jenkins-ci.org/update-center.json,http://updates.jenkins-ci.org/stable/update-center.json,' \
	/var/lib/jenkins/hudson.model.UpdateCenter.xml
echo "Clearing /var/lib/jenkins/updates"
rm -rf /var/lib/jenkins/updates

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%dir %{_sysconfdir}/%{name}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/*.xml
%{_tomcatconfdir}/%{name}.xml
%attr(2775,root,servlet) %dir %{_sharedstatedir}/%{name}
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/META-INF

%dir %{_datadir}/%{name}/WEB-INF
%{_datadir}/%{name}/WEB-INF/classes
%{_datadir}/%{name}/WEB-INF/hudson
%{_datadir}/%{name}/WEB-INF/lib
%{_datadir}/%{name}/WEB-INF/security
%{_datadir}/%{name}/WEB-INF/update-center-rootCAs
%{_datadir}/%{name}/WEB-INF/*.xmi
%{_datadir}/%{name}/WEB-INF/*.xml
%{_datadir}/%{name}/WEB-INF/jenkins-cli.jar
%{_datadir}/%{name}/WEB-INF/remoting.jar
%{_datadir}/%{name}/WEB-INF/slave.jar

%dir %{_datadir}/%{name}/WEB-INF/plugins
%{_datadir}/%{name}/WEB-INF/plugins/ant.hpi
%{_datadir}/%{name}/WEB-INF/plugins/antisamy-markup-formatter.hpi
%{_datadir}/%{name}/WEB-INF/plugins/credentials.hpi
%{_datadir}/%{name}/WEB-INF/plugins/cvs.hpi
%{_datadir}/%{name}/WEB-INF/plugins/external-monitor-job.hpi
%{_datadir}/%{name}/WEB-INF/plugins/javadoc.hpi
%{_datadir}/%{name}/WEB-INF/plugins/junit.hpi
%{_datadir}/%{name}/WEB-INF/plugins/ldap.hpi
%{_datadir}/%{name}/WEB-INF/plugins/mailer.hpi
%{_datadir}/%{name}/WEB-INF/plugins/matrix-auth.hpi
%{_datadir}/%{name}/WEB-INF/plugins/matrix-project.hpi
%{_datadir}/%{name}/WEB-INF/plugins/pam-auth.hpi
%{_datadir}/%{name}/WEB-INF/plugins/script-security.hpi
%{_datadir}/%{name}/WEB-INF/plugins/ssh-credentials.hpi
%{_datadir}/%{name}/WEB-INF/plugins/ssh-slaves.hpi
%{_datadir}/%{name}/WEB-INF/plugins/subversion.hpi
%{_datadir}/%{name}/WEB-INF/plugins/translation.hpi
%{_datadir}/%{name}/WEB-INF/plugins/windows-slaves.hpi

%{_datadir}/%{name}/css
%{_datadir}/%{name}/executable
%{_datadir}/%{name}/help
%{_datadir}/%{name}/images
%{_datadir}/%{name}/scripts
%{_datadir}/%{name}/*.txt
%{_datadir}/%{name}/favicon.ico

%files plugin-maven
%defattr(644,root,root,755)
%{_datadir}/%{name}/WEB-INF/plugins/maven-plugin.hpi
%changelog
* Tue Nov 17 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/jenkins.git;a=log;h=master

* Tue Nov 17 2015 Elan Ruusamäe <glen@delfi.ee> e434c47
- up to 1.625.2

* Tue Nov 17 2015 Elan Ruusamäe <glen@delfi.ee> ea5b577
- requires jre 1.7

* Wed Oct 28 2015 Elan Ruusamäe <glen@delfi.ee> b5b6e31
- up to 1.625.1

* Tue Sep 08 2015 Elan Ruusamäe <glen@delfi.ee> a0a3ce6
- up to 1.609.3

* Thu Aug 06 2015 Elan Ruusamäe <glen@delfi.ee> d713419
- up to 1.609.2

* Thu Jun 04 2015 Elan Ruusamäe <glen@delfi.ee> 7fd13fc
- up to 1.609.1 (2015-05-29)

* Sat Mar 28 2015 Elan Ruusamäe <glen@delfi.ee> 1ebd664
- up to 1.596.2

* Wed Feb 25 2015 Elan Ruusamäe <glen@delfi.ee> 720a89a
- up to 1.580.3

* Tue Jan 06 2015 Elan Ruusamäe <glen@delfi.ee> e78a1d5
- up to 1.580.2 (2014/12/15)

* Mon Nov 03 2014 Elan Ruusamäe <glen@delfi.ee> 1215839
- up to 1.580.1 LTS

* Fri Oct 17 2014 Elan Ruusamäe <glen@delfi.ee> dfa9331
- up to 1.565.3

* Tue Aug 12 2014 Elan Ruusamäe <glen@delfi.ee> d562be1
- up to 1.565.1-LTS

* Tue Jul 15 2014 Elan Ruusamäe <glen@delfi.ee> 785aea8
- up to v1.554.3 (2014-06-30)

* Tue Feb 18 2014 Andrzej Zawadzki <zawadaa@pld-linux.org> 6fcf03f
- up to 1.532.2

* Fri Jan 10 2014 Elan Ruusamäe <glen@delfi.ee> 46deb9b
- Merge branch LTS branch, update LTS 1.532.1

* Wed Oct 16 2013 Elan Ruusamäe <glen@delfi.ee> 7e90209
- 1.509.4

* Thu Dec 26 2013 Elan Ruusamäe <glen@delfi.ee> baaa2b8
- _tomcatconfdir to /etc
- release 3 (by relup.sh)

* Wed Dec 25 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> e2f9ec4
- release 2 (by relup.sh)

* Fri Sep 13 2013 Elan Ruusamäe <glen@delfi.ee> 9d84c12
- up to 1.509.3

* Tue Aug 20 2013 Elan Ruusamäe <glen@delfi.ee> 678e9bd
- build LTS 1.509.2

